# Deviner un nombre intelligemment
# Pour les réponses, il suffit de taper O ou N en majuscule

def demander(unEssai):
    sQuestion = "Ton nombre est-il plus grand que " + str(unEssai) + ", O ou N ? "
    sReponse = raw_input(sQuestion)
    while sReponse != "O" and sReponse != "N":
        sReponse = raw_input(sQuestion)
    return sReponse

# Plus grand nombre du jeu. La limite pratique est bien plus haute
# mais le jeu va mettre trop de temps.
nValeurMax = 50;

# On initialise les deux variables des bornes
borneInf = 0;
borneSup = nValeurMax;

# On rappelle le principe du jeu
print "Pense a un nombre entre 1 et " + str(nValeurMax) + ". Je vais le deviner!"

# La divination se fait ici.
# Le signe plus grand est strict:
# si ton nombre est 39 et que le jeu te demande si c'est plus grand que 39
# tu dois taper N.

while (borneSup - borneInf) > 1:
    monEssai = borneInf + (borneSup - borneInf) / 2;
    sReponse = demander(monEssai)
    if sReponse == "O":
        borneInf = monEssai
    else:
        borneSup = monEssai
        
    # Tu peux enlever les # des deux lignes d'affichage
    # suivantes pour voir les essais successifs.

    # print "Ma nouvelle borne sup : " + str(borneSup)
    # print "Ma nouvelle borne inf : " + str(borneInf)

# On sort de la boucle quand les bornes 
# ne valent plus que 1.
# La bonne valeur sReponse est dans borneSup !

print "Ton nombre est " + str(borneSup) + "!"

# Pour aller plus loin: tester ce qui est saisi, car
# ici on peut taper n'importe quoi.
