#!/usr/bin/python
# -*- coding: utf-8 -*-
# Projet proximicam.py
 
import RPi.GPIO as GPIO
import time

# Import pour picamera et objet maCam
import picamera               # AJOUT
maCam = picamera.PiCamera()   # AJOUT

GPIO.setmode(GPIO.BOARD)
BrochePIR = 7
 
print "*** Capteur de mouvements PROXIMICAM ***"
print "    Controle-C pour quitter."
 
GPIO.setup(BrochePIR, GPIO.IN)
 
EtatActuel = 0
EtatAvant  = 0

print "Stabilisation du capteur..."
while GPIO.input(BrochePIR) == 1 :
  EtatActuel = 0

print "On commence la surveillance."
 
try :
  while True :
 
    EtatActuel = GPIO.input(BrochePIR)
 
    if EtatActuel == 1 and EtatAvant == 0:
      print "  Quelque chose bouge !"
      EtatAvant=1

      # Souriez pour la photo
      maCam.capture('voleur.jpg')      # AJOUT

    elif EtatActuel == 0 and EtatAvant == 1:
      print "  Restabilisation finie. On traque..."
      EtatAvant = 0
 
    time.sleep(0.01)
 
except KeyboardInterrupt :
  # On nettoie le GPIO
  GPIO.cleanup()
  print "  OK. On quitte !"
# Fin du programme
